
/**
 * Remove escaped HTML entities from string.
 * @param text HTML escaped string
 * @returns Un-escaped string
 */
export function sanitizeEscapedText(text: string): string {
  return text.replace(/\n/g, ' ')
    .replace(/&amp;/g, '&')
    .replace(/&lt;/g, '<')
    .replace(/&gt;/g, '>')
    .replace(/&quot;/g, '"')
    .replace(/&apos;/g, '\'')
    .trim();
}
